--
-- The MTS core EJB project is the base framework for the CDS Framework Middle Tier Service.
--
-- Copyright (C) 2013 New York City Department of Health and Mental Hygiene, Bureau of Immunization
-- Contributions by HLN Consulting, LLC
--
-- This program is free software: you can redistribute it and/or modify it under the terms of the GNU
-- Lesser General Public License as published by the Free Software Foundation, either version 3 of the
-- License, or (at your option) any later version. You should have received a copy of the GNU Lesser
-- General Public License along with this program. If not, see <http://www.gnu.org/licenses/> for more
-- details.
--
-- The above-named contributors (HLN Consulting, LLC) are also licensed by the New York City
-- Department of Health and Mental Hygiene, Bureau of Immunization to have (without restriction,
-- limitation, and warranty) complete irrevocable access and rights to this project.
--
-- This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; THE
-- SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING,
-- BUT NOT LIMITED TO, WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
-- NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS, IF ANY, OR DEVELOPERS BE LIABLE FOR
-- ANY CLAIM, DAMAGES, OR OTHER LIABILITY OF ANY KIND, ARISING FROM, OUT OF, OR IN CONNECTION WITH
-- THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
--
-- For more information about this software, see http://www.hln.com/ice or send
-- correspondence to ice@hln.com.
--

alter table mt_user add column PREFIX VARCHAR(40);
alter table mt_user add column FIRST_NAME VARCHAR(40);
alter table mt_user add column MIDDLE_NAME VARCHAR(40);
alter table mt_user add column LAST_NAME VARCHAR(40);
alter table mt_user add column SUFFIX VARCHAR(40);

update mt_user mu set mu.PREFIX = (select mc.prefix from mt_contact mc where mc.user_id = mu.user_id);
update mt_user mu set mu.FIRST_NAME = (select mc.FIRST_NAME from mt_contact mc where mc.user_id = mu.user_id);
update mt_user mu set mu.MIDDLE_NAME = (select mc.MIDDLE_NAME from mt_contact mc where mc.user_id = mu.user_id);
update mt_user mu set mu.LAST_NAME = (select mc.LAST_NAME from mt_contact mc where mc.user_id = mu.user_id);
update mt_user mu set mu.SUFFIX = (select mc.SUFFIX from mt_contact mc where mc.user_id = mu.user_id);

alter table mt_user alter column FIRST_NAME not null;
alter table mt_user alter column LAST_NAME not null;

alter table MT_CONTACT_ADDRESS drop CONSTRAINT FK_MT_CONADD;
rename column MT_CONTACT_ADDRESS.CONTACT_ID to USER_ID;
rename column mt_contact_address.CONTACT_ADDRESS_ID to address_id;
update MT_CONTACT_ADDRESS mca set mca.user_id = (select mc.user_id from mt_contact mc where mca.user_id = mc.CONTACT_ID);
rename table mt_contact_address to mt_user_address;
alter table MT_USER_ADDRESS add CONSTRAINT FK_MT_CONADD FOREIGN KEY (USER_ID) REFERENCES MT_USER (USER_ID);

alter table MT_CONTACT_EMAIL drop CONSTRAINT FK_MT_CONEMAIL;
rename column MT_CONTACT_EMAIL.CONTACT_ID to USER_ID;
rename column MT_CONTACT_EMAIL.CONTACT_EMAIL_ID to email_id;
update MT_CONTACT_EMAIL mca set mca.user_id = (select mc.user_id from mt_contact mc where mca.user_id = mc.CONTACT_ID);
rename table mt_contact_email to mt_user_email;
alter table MT_USER_EMAIL add CONSTRAINT FK_MT_CONEMAIL FOREIGN KEY (user_id) REFERENCES MT_USER (user_id)

alter table MT_CONTACT_PHONE drop CONSTRAINT FK_MT_CONPHON;
rename column MT_CONTACT_PHONE.CONTACT_ID to USER_ID;
rename column MT_CONTACT_PHONE.CONTACT_PHONE_ID to phone_id;
update MT_CONTACT_PHONE mca set mca.user_id = (select mc.user_id from mt_contact mc where mca.user_id = mc.CONTACT_ID);
rename table mt_contact_phone to mt_user_phone;
alter table MT_USER_PHONE add CONSTRAINT FK_MT_CONPHON FOREIGN KEY (user_id) REFERENCES MT_USER (user_id)
